//compiled with mingw
//"g++ -Wl,--subsystem,windows -s -o clippy clippy.cpp -Wl,-luser32,-lgdi32"

#include <windows.h>

void grab(HWND hWin) {
    RECT r;
    HDC scrDC;
    HBITMAP imgBmp;
    HDC imgDC;

    scrDC = GetDC(NULL);
    imgDC = CreateCompatibleDC(scrDC);
    GetClientRect(hWin,&r);
    imgBmp = CreateCompatibleBitmap(scrDC,r.right,r.bottom);
    SelectObject(imgDC,imgBmp);
    ClientToScreen(hWin,(POINT*)&r);
    BitBlt(imgDC,0,0,r.right,r.bottom,scrDC,r.left,r.top,SRCCOPY);

    OpenClipboard(NULL);
    EmptyClipboard();
    SetClipboardData(CF_BITMAP,imgBmp);
    CloseClipboard();

    ReleaseDC(NULL,imgDC);
    ReleaseDC(NULL,scrDC);
}

int main() {
    if (HWND hWin = FindWindow("Notepad",NULL)) {
        grab(hWin);
        MessageBox(NULL,"Grabbed!","Clippy",MB_OK|MB_ICONINFORMATION);
    } else {
        MessageBox(NULL,"Grabbed!","Notepad window not found",MB_OK|MB_ICONERROR);
    }
    return 0;
}
